/***************************************************************
 * Name:      SearchCtrl.cpp
 * Purpose:   Code for Dialog SearchCtrl
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2025-04-20
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#include "Busqueda.h"

wxBEGIN_EVENT_TABLE(SearchCtrl, wxDialog)
    EVT_CLOSE(SearchCtrl::OnClose)
    EVT_BUTTON(wxID_OK, SearchCtrl::OnOk)
wxEND_EVENT_TABLE()

SearchCtrl::SearchCtrl(wxWindow *wnd, wxString &cad)
    : wxDialog(wnd, -1, _T("wxSearchCtrl")), cadena(cad) {
    wxBoxSizer *boxVertical;

    boxVertical = new wxBoxSizer(wxVERTICAL);

    busca = new wxSearchCtrl(this, idBusqueda);
    boxVertical->Add(busca, wxSizerFlags().Expand().Border());

    boxVertical->Add(CreateStdDialogButtonSizer(wxOK | wxCANCEL), wxSizerFlags().Border());
    SetSizerAndFit(boxVertical);
    busca->SetDescriptiveText(_T("Busca algún animal"));
    busca->ShowCancelButton(true);
    busca->ShowSearchButton(true);
}

SearchCtrl::~SearchCtrl()
{
    //dtor
}

void SearchCtrl::OnClose(wxCloseEvent& event) {
    Destroy();
}

void SearchCtrl::OnOk(wxCommandEvent& event) {
    cadena = busca->GetValue();
    EndModal(wxID_OK);
}
