/***************************************************************
 * Name:      wx020Main.cpp
 * Purpose:   Code for Application Frame
 * Author:    Salvador Pozo (salvapozo@gmail.com)
 * Created:   2025-04-20
 * Copyright: Salvador Pozo (https://conclase.net)
 * License:
 **************************************************************/

#ifdef WX_PRECOMP
#include "wx_pch.h"
#endif

#ifdef __BORLANDC__
#pragma hdrstop
#endif //__BORLANDC__

#include "wx020Main.h"

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__WXMAC__)
        wxbuild << _T("-Mac");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

BEGIN_EVENT_TABLE(wx020Frame, wxFrame)
    EVT_CLOSE(wx020Frame::OnClose)
    EVT_MENU(idMenuQuit, wx020Frame::OnQuit)
    EVT_MENU(idMenuAbout, wx020Frame::OnAbout)
    EVT_MENU(idMenuBusqueda, wx020Frame::OnBusqueda)
END_EVENT_TABLE()

wx020Frame::wx020Frame(wxFrame *frame, const wxString& title)
    : wxFrame(frame, -1, title)
{
    // create a menu bar
    wxMenuBar* mbar = new wxMenuBar();
    wxMenu* fileMenu = new wxMenu(_T(""));
    fileMenu->Append(idMenuBusqueda, _T("&Búsqueda\tAlt-F4"), _T("Control de búsqueda"));
    fileMenu->Append(idMenuQuit, _T("&Salir\tAlt-F4"), _T("Salir de la aplicación"));
    mbar->Append(fileMenu, _T("&Fichero"));

    wxMenu* helpMenu = new wxMenu(_T(""));
    helpMenu->Append(idMenuAbout, _T("&Sobre\tF1"), _T("Muestra información sobre la aplicación"));
    mbar->Append(helpMenu, _T("&Ayuda"));

    SetMenuBar(mbar);

    // create a status bar with some information about the used wxWidgets version
    CreateStatusBar(2);
    SetStatusText(_T("Hola"),0);
    SetStatusText(wxbuildinfo(short_f), 1);
    cadena = _T("");
}


wx020Frame::~wx020Frame()
{
}

void wx020Frame::OnClose(wxCloseEvent &event)
{
    Destroy();
}

void wx020Frame::OnQuit(wxCommandEvent &event)
{
    Destroy();
}

void wx020Frame::OnAbout(wxCommandEvent &event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Bienvenido a..."));
}

void wx020Frame::OnBusqueda(wxCommandEvent &event)
{
    SearchCtrl *dlg = new SearchCtrl(this, cadena);
    if(dlg->ShowModal() == wxID_OK) {
        wxMessageBox(cadena, _T("Búsqueda"));
    }
}
